`timescale 1ns/10ps

module alu (Opcode,
            Operand1,
			Operand2,
			Result
		    );

input [1:0]  Opcode;
input [31:0] Operand1;
input [31:0] Operand2;

output [31:0] Result;

reg [31:0] Result;

always @(Opcode or Operand1 or Operand2)
begin
     case(Opcode)
     2'd0: begin
          Result = Operand1 + Operand2;
     end
     2'd1: begin
	      Result = Operand1 - Operand2;
     end
     2'd2: begin
	      Result = Operand1 * Operand2;
     end
     2'd3: begin
	      Result = Operand2;
     end
	 endcase
end

endmodule
