#include "systemc.h"
#include "AMBA/AMBA.h"

SC_MODULE(ALU_AHB_TLM) {

public:      

  AMBA::AHBLiteTarget_inoutslave_port<4, 32> p_AHB;
  
  SC_HAS_PROCESS(ALU_AHB_TLM);
  ALU_AHB_TLM(sc_module_name   name_) : 
    sc_module(name_),
    p_AHB("p_AHB"),
    opc(0), opn1(0), opn2(0), result(0)
    {
    
    SC_METHOD(receiveWriteData);
    sensitive << p_AHB.getReceiveWriteDataTrfEventFinder();
    dont_initialize();
    
    SC_METHOD(sendReadData);
    sensitive << p_AHB.getSendReadDataTrfEventFinder();
    dont_initialize();
    
    SC_METHOD(sendEoT);
    sensitive << p_AHB.getSendEotTrfEventFinder();
    dont_initialize();
    }
  
  ~ALU_AHB_TLM() {
  }
  
  void receiveWriteData();
  void sendReadData();
  void sendEoT();

  void set_opc(unsigned int data);
  void set_opn1(unsigned int data);
  void set_opn2(unsigned int data);
  void calculation(void);

private:

  unsigned int	opc;
  int		opn1;
  int		opn2;  
  int		result;
   
}; 


