//#include <iomanip.h>
#include "ALU_AHB_TLM.h"

void ALU_AHB_TLM::set_opc (unsigned int data) {

  opc = data;
  calculation();
  return;

}

void ALU_AHB_TLM::set_opn1 (unsigned int data) {

  opn1 = (int) data;
  calculation();
  return;
}

void ALU_AHB_TLM::set_opn2 (unsigned int data) {

  opn2 = (int) data;
  calculation();
  return;
}

void ALU_AHB_TLM::calculation (void) {

  switch (opc) {
  case 0x00000000 :
    result = opn1 + opn2;
    break;
  case 0x00000001 :
    result = opn1 - opn2;
    break;
  case 0x00000002 :
    result = opn1 * opn2;
    break;
  case 0x00000003 :
    result = opn2;
  default :
    cout << "***** ERROR: WRONG OPCODE" << endl;
    sc_stop();
    break;
  }
}


void ALU_AHB_TLM::receiveWriteData() {

  unsigned int address, data; 

  p_AHB.getWriteDataTrf();
  address = (p_AHB.WriteDataTrf->getAddrTrf()->getAddress()) & 0x0000000F;
  data = p_AHB.WriteDataTrf->getWriteData();

  switch (address) {
  case 0x00000000 :
    set_opc(data);    
    break;
  case 0x00000004 :
    set_opn1(data);
    break;
  case 0x00000008 :
    set_opn2(data);
    break;
  default:
    cout << "***** ERROR: WRONG ACCESS ADDRESS" << endl;
    sc_stop();
    break;
  }  
}

void ALU_AHB_TLM::sendReadData() {
  unsigned int address;  
  unsigned int data;

  p_AHB.getReadDataTrf();
  address = (p_AHB.ReadDataTrf->getAddrTrf()->getAddress()) & 0x0000000F;

  if (address==0x0000000C){              
    data = result;
    p_AHB.ReadDataTrf->setReadData(data);
    p_AHB.sendReadDataTrf();
  }
  else {
    cout << "***** ERROR: WRONG ACCESS ADDRESS" << endl;
    sc_stop();
  }
}

void ALU_AHB_TLM::sendEoT () {      
  p_AHB.sendEotTrf();
}


