//==================================================================
//  AHB TLM Display (simple peripheral)
//==================================================================
#ifndef DISPLAY_AHB_TLM_H
#define DISPLAY_AHB_TLM_H

#include "systemc.h"
#include "AMBA/AMBA.h"

class display_AHB_TLM : public sc_module {
public:
      
    AMBA::AHBTarget_inslave_port<1, 32>  din;		// Ports

    SC_HAS_PROCESS(display_AHB_TLM);

    display_AHB_TLM(sc_module_name name) 	// Constructor
    : sc_module(name),
      din("din"),
      temp(0)
    {
      SC_METHOD(printValue);
      sensitive << din.getReceiveWriteDataTrfEventFinder();
      dont_initialize();

      SC_METHOD(sendEoT);
      sensitive << din.getSendEotTrfEventFinder();
      dont_initialize();
    } 
  
    void printValue();				// Processes
    void sendEoT();

private:
    unsigned int temp;
}; 

#endif 
