//==================================================================
//  APB TLM Display (simple peripheral)
//==================================================================
#ifndef DISPLAY_APB_TLM_H
#define DISPLAY_APB_TLM_H

#include "systemc.h"
#include "AMBA/AMBA.h"

class display_APB_TLM : public sc_module {
public:
      
    AMBA::APBTarget_inslave_port<1, 32>  din;		// Ports

    SC_HAS_PROCESS(display_APB_TLM);

    display_APB_TLM(sc_module_name name) 	// Constructor
    : sc_module(name),
      din("din"),
      temp(0)
    {
      SC_METHOD(printValue);
      sensitive << din.getReceiveWriteDataTrfEventFinder();
      dont_initialize();

      SC_METHOD(sendEoT);
      sensitive << din.getSendEotTrfEventFinder();
      dont_initialize();
    } 
  
    void printValue();				// Processes
    void sendEoT();

private:
    int temp;
}; 

#endif 
