#ifndef _HPG_display_APB_Vlog_h_H_
#define _HPG_display_APB_Vlog_h_H_

#include "systemc.h"

SC_HDL_MODULE( display_APB_Vlog) {
    sc_in<bool> clk;
    sc_in<sc_uint<1> > PADDR;
    sc_in<bool> PENABLE;
    sc_in<bool> PSEL;
    sc_in<sc_uint<32> > PWDATA;

    std::string hpg_log_lib;
    std::string hpg_module_name;
    std::string hpg_hdl_src_path;

    std::string libraryName() { return hpg_log_lib; }

    std::string moduleName() { return hpg_module_name; }

    cwr_hdlLangType hdl_language_type() { return sc_hdl_module::cwr_verilog; }

    void getVerilogSourceFiles(std::vector<std::string>& verilog_files) {
        verilog_files.push_back(hpg_hdl_src_path + std::string("../../library/displayLib/src/display_APB.v"));
    }

    display_APB_Vlog(sc_module_name name, const char* hdlSrcPath="") : 
        sc_hdl_module(name), hpg_log_lib("myLib"), hpg_module_name("display_APB_Vlog"), hpg_hdl_src_path()
        , clk("clk"), PADDR("PADDR"), PENABLE("PENABLE"), PSEL("PSEL"), PWDATA("PWDATA") {

        if (hdlSrcPath != 0 && strlen(hdlSrcPath) != 0) {
          hpg_hdl_src_path = std::string(hdlSrcPath) + "/";
        }


    }
};

#endif
